<template>
  <v-row align="center" class="px-3 mx-auto">
    <v-col cols="12">
      <v-card class="mx-auto" tile>
        <v-data-table
          :headers="headers"
          :items="reports"
          :items-per-page="10000"
          class="elevation-1"
          :hide-default-footer="true"
          :loading="loading"
          :loading-text="loading_text"
          :search="search"
        >
          <template v-slot:top>
            <v-toolbar flat>
              <v-toolbar-title>Failed LBF Patches</v-toolbar-title>
              <v-divider class="mx-4" inset vertical></v-divider>
              <v-spacer></v-spacer>
            </v-toolbar>
          </template>
          <template v-slot:item.actions="{ item }">
            <v-btn color="primary" icon @click.prevent="handleRetry(item)">
              <v-icon small class="mr-2"> mdi-refresh </v-icon>
            </v-btn>
          </template>
        </v-data-table>
      </v-card>
    </v-col>
  </v-row>
</template>

<script>
export default {
  name: "ReportsTable",
  mounted() {
    this.$store.dispatch("fetchReports");
  },
  computed: {
    reports() {
      return this.$store.state.reports;
    },
  },
  data() {
    return {
      loading: false,
      search: "",
      loading_text: "Loading... Please wait",
      headers: [
        {
          text: "ID",
          value: "id",
          align: "start",
          sortable: true,
        },
        { text: "Account ID", value: "loanId", sortable: false },
        { text: "Encoded Key", value: "encodedKey", sortable: true },
        {
          text: "Error Code",
          value: "errorCode",
          align: "start",
          sortable: false,
        },
        {
          text: "Reason",
          value: "errorReason",
          align: "start",
          sortable: false,
        },
        {
          text: "Error Source",
          value: "errorSource",
          align: "start",
          sortable: false,
        },
        {
          text: "Retry",
          value: "actions",
          align: "start",
        },
      ],
    };
  },
  methods: {
    handleRetry(item) {
      console.log(item);

      this.$store.dispatch("handleRetry", item).then((val) => {
        console.log(val);
      }).finally(()=>{
        this.$store.dispatch("fetchReports");
      })
    },
  },
};
</script>

<style>
.list {
  max-width: 750px;
}
</style>
